#ifndef __DS1340_h
#define __DS1340_h

#include <Arduino.h>

typedef struct 
{
byte    Second;     // Store second value
byte    Minute;     // Store minute value
byte    Hour;       // Store hour value
byte    Day;        // Store day value
byte    Date;       // Store date value
byte    Month;      // Store month value
byte    Year;       // Store year value
} DateAndTime;

class DS1340_I2CRTC
{
	private:
		int I2C_address;
		DateAndTime dt;				// Data is stored here in int format, not BCD as the chip does
		int _fromBCD(byte bcd);
		byte _toBCD(int value);
		
	
	public:
		DS1340_I2CRTC();
		void init();						// Initialize the object and connect to I2C bus
		void setTime(DateAndTime *pdt);		// Sets the object date and time (does not write to chip)
		void setTime(int hour, int minute, int second, int year, int month, int date);	// Same as above
		void setRTCTime(DateAndTime *pdt);	// Writes the the data to RTC chip. If pdt is NULL writes DateAndTime stored in the object
		DateAndTime *getTime(DateAndTime *pdt);		// If parameter is NULL stores in object and return pointer to it
};
 
 
 extern DS1340_I2CRTC 		rtcModule;

#endif